import 'dart:convert';
import 'package:dart_openbank/pbmodels/product.pb.dart';
import 'package:dart_openbank/pbmodels/productlist.pb.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:dart_openbank/dart_openbank.dart';

void main() {

String productlistJSON = r"""
{"data":{"products":[{"productId":"ad22b1f0967349e8a5d586afe7f0d845","effectiveFrom":"2019-07-23T00:00:01Z","effectiveTo":"9999-12-30T13:00:00Z","lastUpdated":"2019-07-18T14:38:09Z","productCategory":"TRANS_AND_SAVINGS_ACCOUNTS","name":"NetBank Saver","description":"An online savings account with the flexibility to move money in and out of your linked CommBank transaction account using NetBank or the CommBank app.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/banking/netbank-saver.html#apply","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/banking/netbank-saver.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/SavingsInvestment_ADB2852.pdf","eligibilityUri":"https://www.commbank.com.au/banking/netbank-saver.html#apply","feesAndPricingUri":"https://www.commbank.com.au/banking/netbank-saver.html#rates"}},{"productId":"7aff9e0e85e6450eb052d4ff2e953223","effectiveFrom":"2019-07-23T00:00:01Z","effectiveTo":"9999-12-30T13:00:00Z","lastUpdated":"2019-07-18T14:38:09Z","productCategory":"TRANS_AND_SAVINGS_ACCOUNTS","name":"Youthsaver Account","description":"Designed to help teach saving skills to under 18s, our Youthsaver account offers bonus interest for reaching saving goals.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/banking/youthsaver.html#apply","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/banking/youthsaver.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/SavingsInvestment_ADB2852.pdf","eligibilityUri":"https://www.commbank.com.au/banking/youthsaver.html#apply","feesAndPricingUri":"https://www.commbank.com.au/banking/youthsaver.html#rates"}},{"productId":"72f214498c7f47a98fe59b794e7c01ab","effectiveFrom":"2019-07-23T00:00:01Z","effectiveTo":"9999-12-30T13:00:00Z","lastUpdated":"2019-07-18T14:38:09Z","productCategory":"TRANS_AND_SAVINGS_ACCOUNTS","name":"GoalSaver","description":"Be rewarded with a variable bonus rate for saving regularly each month.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/banking/goal-saver.html#apply","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/banking/goal-saver.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/SavingsInvestment_ADB2852.pdf","eligibilityUri":"https://www.commbank.com.au/banking/goal-saver.html#applyhow","feesAndPricingUri":"https://www.commbank.com.au/banking/goal-saver.html#rates"}},{"productId":"7375f63775b4489a890655e25395e12d","effectiveFrom":"2019-07-23T00:00:01Z","effectiveTo":"9999-12-30T13:00:00Z","lastUpdated":"2019-07-18T14:38:09Z","productCategory":"TRANS_AND_SAVINGS_ACCOUNTS","name":"Pensioner Security","description":"A flexible account that keeps your retirement savings or pension income safe and working for you.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/banking/pensioner-security.html#apply","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/banking/pensioner-security.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/SavingsInvestment_ADB2852.pdf","eligibilityUri":"https://www.commbank.com.au/banking/pensioner-security.html#apply","feesAndPricingUri":"https://www.commbank.com.au/banking/pensioner-security.html#rates"}},{"productId":"33557e367d324529b38813adfc655b55","effectiveFrom":"2010-07-14T14:00:00Z","effectiveTo":"9999-12-30T13:00:00Z","lastUpdated":"2019-05-29T05:38:26.442348Z","productCategory":"TRANS_AND_SAVINGS_ACCOUNTS","name":"Smart Access","description":"An everyday bank account, giving you access to unlimited electronic transactions and features to help your spending and bills stay on track. Plus if you meet certain criteria, we'll waive your $4 monthly account fee.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/banking/everyday-account-smart-access.html#apply","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/banking/everyday-account-smart-access.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/SavingsInvestment_ADB2852.pdf","eligibilityUri":"https://www.commbank.com.au/banking/everyday-account-smart-access.html#who","feesAndPricingUri":"https://www.commbank.com.au/banking/everyday-account-smart-access/rates-fees.html"}},{"productId":"5921439d2525442da3841a25572a740e","effectiveFrom":"2010-07-14T14:00:00Z","effectiveTo":"9999-12-30T13:00:00Z","lastUpdated":"2019-05-27T07:56:59.274923Z","productCategory":"TRANS_AND_SAVINGS_ACCOUNTS","name":"Streamline Basic","description":"An everyday bank account for health care or pensioner concession card holders.","brand":"CBA","brandName":"CommBank","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/banking/streamline-basic.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/SavingsInvestment_ADB2852.pdf","eligibilityUri":"https://www.commbank.com.au/banking/streamline-basic.html#who","feesAndPricingUri":"https://www.commbank.com.au/banking/streamline-basic.html#rates"}},{"productId":"c50f2a2cf77c47248ebbb565d2d6c1cb","effectiveFrom":"2011-05-10T14:00:00Z","effectiveTo":"9999-12-30T13:00:00Z","lastUpdated":"2019-05-29T05:38:16.875435Z","productCategory":"TRANS_AND_SAVINGS_ACCOUNTS","name":"Private Bank Account","description":"The Commonwealth Private Bank Account is an exclusive transaction account for Commonwealth Private clients.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/premier-private/private-banking.html","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/premier-private/private-banking.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/download-printed-forms/premier-and-private-banking/commonwealth-private-financial-services-guide.pdf","eligibilityUri":"https://www.commbank.com.au/premier-private/private-banking.html","feesAndPricingUri":"https://www.commbank.com.au/personal/docs/CBA1026_Commonwealth_Private_TCs.pdf"}},{"productId":"523f5c6a7e5b46e78a533e3272faeb97","effectiveFrom":"2009-12-31T13:00:00Z","effectiveTo":"9999-12-30T13:00:00Z","lastUpdated":"2019-08-09T01:53:13.968522Z","productCategory":"TERM_DEPOSITS","name":"Standard Term Deposit","description":"Feel confident knowing exactly how much your money will earn. Lock-in a competitive interest rate from as short as 1 month to as long as 5 years.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/banking/term-deposits.html#apply","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/banking/term-deposits.html","termsUri":"https://www.commbank.com.au/personal/apply-online/download-printed-forms/TermDeposit_ADB202.pdf","eligibilityUri":"https://www.commbank.com.au/banking/term-deposits.html","feesAndPricingUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/InvInterestRates_ADB1072.pdf"}},{"productId":"f70238d4ee324ad99af6ee0f01f7cdde","effectiveFrom":"2011-05-10T14:00:00Z","effectiveTo":"9999-12-30T13:00:00Z","lastUpdated":"2019-05-29T05:38:06.036435Z","productCategory":"TRANS_AND_SAVINGS_ACCOUNTS","name":"Business Transaction Account","description":"An everyday business bank account that you can open online, which provides unlimited electronic transactions and 20 assisted transactions on a monthly basis. Fees and charges will apply if you exceed this amount. Please note Access, CommBiz and NetBank Service Fees may apply and are excluded from the unlimited electronic transactions.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/business/banking-and-cards/bank-accounts/business-transaction-account.html#apply","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/business/banking-and-cards/bank-accounts/business-transaction-account.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/business/pds/ADB2916.pdf","eligibilityUri":"https://www.commbank.com.au/business/banking-and-cards/bank-accounts/business-transaction-account.html#apply","feesAndPricingUri":"https://www.commbank.com.au/business/banking-and-cards/bank-accounts/business-transaction-account.html#rates"}},{"productId":"b31f8ddfc16b4121a0522fdc4af6cf7e","effectiveFrom":"2019-07-23T00:00:01Z","effectiveTo":"9999-12-30T13:00:00Z","lastUpdated":"2019-07-18T14:38:09Z","productCategory":"TRANS_AND_SAVINGS_ACCOUNTS","name":"Business Online Saver","description":"A business savings account that can help you manage cash flow and set aside money for tax payments.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/business/banking-and-cards/bank-accounts/business-online-saver.html#how","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/business/banking-and-cards/bank-accounts/business-online-saver.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/business/pds/ADB2916.pdf","eligibilityUri":"https://www.commbank.com.au/business/banking-and-cards/bank-accounts/business-online-saver.html#how","feesAndPricingUri":"https://www.commbank.com.au/business/banking-and-cards/bank-accounts/business-online-saver.html#Rates"}},{"productId":"07546f4ac1d4455d8dd2f3954d33ca68","effectiveFrom":"2011-05-10T14:00:00Z","effectiveTo":"9999-12-30T13:00:00Z","lastUpdated":"2019-05-29T05:38:16.330527Z","productCategory":"TRANS_AND_SAVINGS_ACCOUNTS","name":"Standard Business Cheque Account - Interest Bearing Option","description":"Transaction accounts that pays interest above minimum balances","brand":"CBA","brandName":"CommBank","isTailored":true,"additionalInformation":{"feesAndPricingUri":"https://www.commbank.com.au/business/rates-fees.html"}},{"productId":"d44d38acc5b34c5bb76117f290d97134","effectiveFrom":"2014-12-31T13:00:00Z","effectiveTo":"2099-12-30T13:00:00Z","lastUpdated":"2019-05-20T21:20:03.13664Z","productCategory":"CRED_AND_CHRG_CARDS","name":"Corporate Low Rate card","description":"Designed for medium businesses wishing to manage their cash flow by paying down larger items over time. Options to monitor employee expenses, set limits and access expense reports in order to minimise costs.","brand":"CBA","brandName":"CommBank","isTailored":true,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/business/business-credit-cards/cards-for-larger-business/corporate-low-rate-card.html","termsUri":"https://www.commbank.com.au/content/dam/commbank-assets/business/banking/2019-06/ctc-for-business-finance.pdf","eligibilityUri":"https://www.commbank.com.au/business/business-credit-cards/cards-for-larger-business/corporate-low-rate-card.html","feesAndPricingUri":"https://www.commbank.com.au/content/dam/commbank/business/pds/001-033-corporate-card-fees.pdf"}},{"productId":"a24ddd5d53b5447abe15665b73be4597","effectiveFrom":"2014-12-31T13:00:00Z","effectiveTo":"2099-12-30T13:00:00Z","lastUpdated":"2019-05-20T21:20:03.13664Z","productCategory":"CRED_AND_CHRG_CARDS","name":"Corporate Interest Free Days card","description":"Designed for medium to large businesses wanting to maximise cash flow with interest free days on purchases, monitor employee expenses, set transaction limits and access expense reports in order to track, analyse and forecast expenses.","brand":"CBA","brandName":"CommBank","isTailored":true,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/business/business-credit-cards/cards-for-larger-business/corporate-interest-free-days-card.html","termsUri":"https://www.commbank.com.au/content/dam/commbank-assets/business/banking/2019-06/ctc-for-business-finance.pdf","eligibilityUri":"https://www.commbank.com.au/business/business-credit-cards/cards-for-larger-business/corporate-interest-free-days-card.html","feesAndPricingUri":"https://www.commbank.com.au/content/dam/commbank/business/pds/001-033-corporate-card-fees.pdf"}},{"productId":"7e2c7d0942774f04935428ca31e5512b","effectiveFrom":"2014-12-31T13:00:00Z","effectiveTo":"2099-12-30T13:00:00Z","lastUpdated":"2019-05-20T21:20:03.13664Z","productCategory":"CRED_AND_CHRG_CARDS","name":"Corporate charge card","description":"Ideal for large organisations with significant expenses. You can set spending limits and access expense reports to monitor spending and forecast costs.","brand":"CBA","brandName":"CommBank","isTailored":true,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/business/business-credit-cards/cards-for-larger-business/corporate-charge-card.html","termsUri":"https://www.commbank.com.au/content/dam/commbank-assets/business/banking/2019-06/ctc-for-business-finance.pdf","eligibilityUri":"https://www.commbank.com.au/business/business-credit-cards/cards-for-larger-business/corporate-charge-card.html","feesAndPricingUri":"https://www.commbank.com.au/content/dam/commbank/business/pds/001-033-corporate-card-fees.pdf"}},{"productId":"af40eb5f63ce4dbf854d556abdd1e6d1","effectiveFrom":"2014-12-31T13:00:00Z","effectiveTo":"9999-12-31T13:00:00Z","lastUpdated":"2019-05-29T16:16:15.739015Z","productCategory":"CRED_AND_CHRG_CARDS","name":"Diamond Awards credit card","description":"Our credit card with the highest rewards earning potential. For customers willing to pay a higher annual fee for our ultimate Awards experience.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/credit-cards/diamond.html","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/credit-cards/diamond.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/cc2-cou.pdf","eligibilityUri":"https://www.commbank.com.au/credit-cards/diamond.html","feesAndPricingUri":"https://www.commbank.com.au/personal/apply-online/download-printed-forms/ADB1682.pdf"}},{"productId":"67b2f138050940d8977cbbaebbfcc636","effectiveFrom":"2014-12-31T13:00:00Z","effectiveTo":"9999-12-31T00:00:00Z","lastUpdated":"2019-05-29T16:16:15.739811Z","productCategory":"CRED_AND_CHRG_CARDS","name":"Low Rate credit card","description":"With a low interest rate on purchases, our Low Rate credit card makes it easier to pay off purchases over time.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/credit-cards/low-rate.html","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/credit-cards/low-rate.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/cc2-cou.pdf","eligibilityUri":"https://www.commbank.com.au/credit-cards/low-rate.html","feesAndPricingUri":"https://www.commbank.com.au/personal/apply-online/download-printed-forms/ADB1682.pdf"}},{"productId":"230331577b2643a3ac965618877c84ce","effectiveFrom":"2014-12-31T13:00:00Z","effectiveTo":"9999-12-31T13:00:00Z","lastUpdated":"2019-05-29T16:16:15.741311Z","productCategory":"CRED_AND_CHRG_CARDS","name":"Low Rate Gold credit card","description":"Stay in control of your finances with our low purchase interest rate, plus handy extras like international travel insurance.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/credit-cards/low-rate-gold.html","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/credit-cards/low-rate-gold.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/cc2-cou.pdf","eligibilityUri":"https://www.commbank.com.au/credit-cards/low-rate-gold.html","feesAndPricingUri":"https://www.commbank.com.au/credit-cards/low-rate-gold.html#rates"}},{"productId":"99563efaa4324acea46c213d7d96dd8c","effectiveFrom":"2014-12-31T13:00:00Z","effectiveTo":"9999-12-31T13:00:00Z","lastUpdated":"2019-05-29T16:16:15.741745Z","productCategory":"CRED_AND_CHRG_CARDS","name":"Low Fee Gold","description":"Enjoy the flexibility and convenience of a credit card with no annual fee in the first year and included international travel insurance (restrictions, exclusions (including for pre-existing medical conditions and persons aged 80 years or over), limits, sub-limits and excesses apply).","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/credit-cards/low-fee-gold.html","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/credit-cards/low-fee-gold.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/cc2-cou.pdf","eligibilityUri":"https://www.commbank.com.au/credit-cards/low-fee-gold.html","feesAndPricingUri":"https://www.commbank.com.au/credit-cards/low-fee-gold.html#rates"}},{"productId":"6512302188d8496baba2fbfd7dbba9a7","effectiveFrom":"2014-12-31T13:00:00Z","effectiveTo":"9999-12-31T13:00:00Z","lastUpdated":"2019-05-29T16:16:15.742149Z","productCategory":"CRED_AND_CHRG_CARDS","name":"Awards credit card","description":"For customers who want a lower annual fee and credit limit, but still like to earn Awards points.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/personal/credit-cards/awards.html","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/personal/credit-cards/awards.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/cc2-cou.pdf","eligibilityUri":"https://www.commbank.com.au/personal/credit-cards/awards.html","feesAndPricingUri":"https://www.commbank.com.au/personal/apply-online/download-printed-forms/ADB1682.pdf"}},{"productId":"6a43e44746b44f2dad11a5f0c75ef8f3","effectiveFrom":"2014-12-31T13:00:00Z","effectiveTo":"2099-12-30T13:00:00Z","lastUpdated":"2019-05-29T16:16:15.742569Z","productCategory":"CRED_AND_CHRG_CARDS","name":"Platinum Awards credit card","description":"A credit card with the opportunity to earn Awards points and take advantage of extras like international travel insurance.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/credit-cards/platinum.html","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/credit-cards/platinum.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/cc2-cou.pdf","eligibilityUri":"https://www.commbank.com.au/credit-cards/platinum.html","feesAndPricingUri":"https://www.commbank.com.au/personal/apply-online/download-printed-forms/ADB1682.pdf"}},{"productId":"4002561833054353a1fe48d27be120aa","effectiveFrom":"2014-12-31T13:00:00Z","effectiveTo":"9999-12-31T00:00:00Z","lastUpdated":"2019-05-29T16:16:15.743061Z","productCategory":"CRED_AND_CHRG_CARDS","name":"Low Rate credit card","description":"Ideal for small business owners looking for a line of credit with a competitive interest rate and no annual fee. Note, this product does not include an interest free day period.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/business/business-credit-cards/business-low-rate-credit-card.html","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/business/business-credit-cards/business-low-rate-credit-card.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/cc2-cou.pdf","eligibilityUri":"https://www.commbank.com.au/business/business-credit-cards/business-low-rate-credit-card.html","feesAndPricingUri":"https://www.commbank.com.au/content/dam/commbank/business/pds/003-840-personal-liability-card-fees.pdf"}},{"productId":"5b47845a7f0044e58db616bb734e8350","effectiveFrom":"2014-12-31T13:00:00Z","effectiveTo":"9999-12-31T00:00:00Z","lastUpdated":"2019-05-29T16:16:15.743521Z","productCategory":"CRED_AND_CHRG_CARDS","name":"Interest-Free Days credit card","description":"Designed for those looking for a card with a competitive interest-free period to help with business cash flow.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/business/business-credit-cards/business-interest-free-days-credit-card.html","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/business/business-credit-cards/business-interest-free-days-credit-card.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/cc2-cou.pdf","eligibilityUri":"https://www.commbank.com.au/business/business-credit-cards/business-interest-free-days-credit-card.html","feesAndPricingUri":"https://www.commbank.com.au/content/dam/commbank/business/pds/003-840-personal-liability-card-fees.pdf"}},{"productId":"5f05d7f60e0040bfbc4f3a89c3181f5f","effectiveFrom":"2014-12-31T13:00:00Z","effectiveTo":"9999-12-31T00:00:00Z","lastUpdated":"2019-05-29T16:16:15.743944Z","productCategory":"CRED_AND_CHRG_CARDS","name":"Business Awards credit card","description":"Perfect for those looking for a competitive interest-free period on purchases and to reward themselves for business purchases.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/business/business-credit-cards/business-awards-credit-cards/business-awards-credit-card.html","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/business/business-credit-cards/business-awards-credit-cards/business-awards-credit-card.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/cc2-cou.pdf","eligibilityUri":"https://www.commbank.com.au/business/business-credit-cards/business-awards-credit-cards/business-awards-credit-card.html","feesAndPricingUri":"https://www.commbank.com.au/personal/apply-online/download-printed-forms/ADB1682.pdf"}},{"productId":"8df91527a5774d7bb795eebe2509f941","effectiveFrom":"2014-12-31T13:00:00Z","effectiveTo":"9999-12-31T00:00:00Z","lastUpdated":"2019-05-29T16:16:15.744511Z","productCategory":"CRED_AND_CHRG_CARDS","name":"Business Platinum Awards credit card","description":"Earn 1 Awards point for every dollar you spend on your business expenses.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/business/business-credit-cards/business-awards-credit-cards/business-awards-platinum-credit-card.html","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/business/business-credit-cards/business-awards-credit-cards/business-awards-platinum-credit-card.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/cc2-cou.pdf","eligibilityUri":"https://www.commbank.com.au/business/business-credit-cards/business-awards-credit-cards/business-awards-platinum-credit-card.html","feesAndPricingUri":"https://www.commbank.com.au/personal/apply-online/download-printed-forms/ADB1682.pdf"}},{"productId":"d13dbe5f4f3b424298056d93c1079b00","effectiveFrom":"2014-12-31T13:00:00Z","effectiveTo":"9999-12-30T13:00:00Z","lastUpdated":"2019-05-29T16:16:15.745547Z","productCategory":"CRED_AND_CHRG_CARDS","name":"CommBank Essentials credit card","description":"A simple card with our lowest rate on purchases, helping you stay in control.","brand":"CBA","brandName":"CommBank","applicationUri":"https://www.commbank.com.au/credit-cards/commbank-essentials.html","isTailored":false,"additionalInformation":{"overviewUri":"https://www.commbank.com.au/credit-cards/commbank-essentials.html","termsUri":"https://www.commbank.com.au/content/dam/commbank/personal/apply-online/download-printed-forms/cc2-cou.pdf","eligibilityUri":"https://www.commbank.com.au/credit-cards/commbank-essentials.html","feesAndPricingUri":"https://www.commbank.com.au/personal/apply-online/download-printed-forms/ADB1682.pdf"}}]},"links":{"self":"https://api.commbank.com.au/public/cds-au/v1/banking/products","first":"https://api.commbank.com.au/public/cds-au/v1/banking/products?page=1&page-size=25","next":"https://api.commbank.com.au/public/cds-au/v1/banking/products?page=2&page-size=25","last":"https://api.commbank.com.au/public/cds-au/v1/banking/products?page=2&page-size=25"},"meta":{"totalRecords":44,"totalPages":2}}
""";

String invlidProductJsonString = r"""
{
  "invalidData": {
    "test": "wrong data"
  }
}
""";

  test('ProductList json to protobuf should be correct', () {
    ProductList plist = new ProductList();
    var jsonObj = json.decode(productlistJSON);
    plist.mergeFromProto3Json(jsonObj, ignoreUnknownFields: true);
    expect(plist.data.products.length, equals(25));
    expect(plist.data.products.first.brand, equals("CBA"));
    expect(plist.meta.totalPages, equals(2));
    expect(plist.links.hasFirst(), equals(true));
  });

  test('Exception should be thrown when decode invalid product json ', () {
    var jsonObj = json.decode(invlidProductJsonString);
    Product p = new Product();
    try {
      p.mergeFromProto3Json(jsonObj);
    } catch (err) {
      expect(err, isFormatException);
    }
  });

  test('Get ANZ Products API should return correct product', () async {
    OBConfiguration config = ANZConfiguration();
    OBClient client = OBClient(config);
    expect(client, isNotNull);
    expect(client.bankName, equals(config.name));
    expect(client.baseUri.toString(),
        equals("${config.baseUrl.toString()}/v${config.version}/${OBClient.rootPath}"));
    ProductList products = await client.getProducts();
    expect(products.data.products.first.brand, equals("ANZ"));
  });
}
